/* test.c */
/* Uses one header and one library (vstrack1). */
/* Simple test that prints data to screen. */
/* Created  2/13/95 */
/* Ken Hawkins */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include "vstrack1.h"

void main(int argc,char ** argv) {
TrackerData td;
TrackerStatus ts;
TrackerPort trackerPort;

  printf("Initializing tracker.\n");

  ts = initTrackerSearch(&td,&trackerPort,9600,timerSecs(2));
  printf("%s.\n",trackerInfo(ts));
  if (ts != TS_OK) {
    closeTracker(&td);
    exit(0);
  } // if

  ts = sendTrackerCMD(&td,"!M1,P,B\r",timerSecs(2));
  if (ts != TS_OK) {
    printf("%s.\n",trackerInfo(ts));
    closeTracker(&td);
    exit(0);
  } // if

  requestTrackerData(&td);

  while (1) {
    float y,p,p2,r;
    if (kbhit() && getch() == 'q') break;

    ts = readTracker(&td,timerSecs(1));
    if (ts != TS_OK) {
      printf("\n%s.\n",trackerInfo(ts));
	  ts = resetTracker(&td,timerTSecs(1));
      if (ts != TS_OK) {
        printf("\n%s.\n",trackerInfo(ts));
	  } // if
    } // if
    requestTrackerData(&td);

    y = TOFLOAT(td.euler.y);
    p = TOFLOAT(td.euler.x);
    r = TOFLOAT(td.euler.z);

    printf("x %6ld y %6ld z %6ld y %6.2f p %6.2f r %6.2f\n",
      td.magnetic.x,td.magnetic.y,td.magnetic.z,y,p,r);

  } // while

  closeTracker(&td);

} // main

/* test.c */

