typedef unsigned char BYTE;

/*----Video definitions----*/
#define VIDEO_INT		0x10
#define SET_VMODE		0
#define CRTC_ADDRESS	0x3d4
#define CRTC_DATA		0x3d5
#define UNDERLINE_LOC	0x14
#define MODE80X25		3
#define PRESET_ROW_SCAN	8
#define BORDER_CHAR		177
#define FILL_CHAR		219

/*----Keyboard definitions----*/
#define ESC		27
#define TAB		9
#define STAB	15
#define ENTER	13
#define SPACE	32
#define UP		72
#define DOWN	80
#define LEFT	75
#define RIGHT	77

/*----Program Definitions----*/
#define INC			1
#define DEC			-1
#define ITOC(a)		((a) + 48)
#define ABS(a)		((a) >= 0 ? (a) : -(a))
#define SWAP(a,b)	{long temp = a; a = b; b = temp;}
#define EMUMOUSE	0
#define EMUJOY		1

/*----Color definitions----*/
enum colors {
	BLACK,
	BLUE,
	GREEN,
	CYAN,
	RED,
	MAGENTA,
	BROWN,
	WHITE,
	GRAY,
	LIGHTBLUE,
	LIGHTGREEN,
	LIGHTCYAN,
	LIGHTRED,
	LIGHTMAGENTA,
	YELLOW,
	BRIGHTWHITE
};

/*----Window Definition----*/
enum windows {
	HELP,
	EMULATION,
	XFILTER,
	YFILTER,
	XSENSITIVITY,
	YSENSITIVITY,
	XTHRESHOLD,
	YTHRESHOLD,
};

typedef struct{
 short x1;		// box corner coordinates
 short x2;
 short y1;
 short y2;
 BYTE fclr;	//forground border color
 BYTE bclr;	//background color
 BYTE tclr;	//text color
 char *btext;
} BUTTON;

typedef struct{
 short x1;	//box corner coordinates
 short x2;
 short y1;
 short y2;
 BYTE fclr;	//forground border color
 BYTE bclr;	//background color
 BYTE tclr;	//text color
 long sval;	//current slider value
} SLIDE;
