/* clip.h */
/* Created 1/15/95 */
/* Copyright 1998 Ken Hawkins */
/* All Rights Reserved */

#ifndef CLIP_H
#define CLIP_H

typedef struct {
  vec3 min,max;
} box;

typedef struct { /* Stereo sep, mag, center, & clipping */
  coord msep;    /* Multiplied separation factor for stereo */
  vec2 vmag;     /* Magnification */
  vec2 center;   /* Screen center (Offset by sep. factor when stereo) */
  box clip;      /* 3D clipping box */
} stereoSMC;

//*** Stereo separation, magnification, and clipping setup ***

void setStereoSMC(stereoSMC * smc);

// *** Projection ***

void project3mono(vec2 * pm,vec3 * p);
void project3stereo(vec2 * ps,vec3 * p);

// *** Clipping ***

long clipPoint2(vec2 * p);
long clipLine2(vec2 * l);
long clipLine3(vec3 * l);

// *** Projection and clipping ***

// *** Mono ***

long projClipPointMono(vec2 * out,vec3 * in);
long projClipLineMono(vec2 * out,vec3 * in);

// ** Stereo ***

long projClipPointStereo(vec2 * out,vec3 * in);
long projClipLineStereo(vec2 * out,vec3 * in);

#endif

/* clip.h */
