/* gfx.h */
/* Created 12/12/94 */

#ifndef GFX_H
#define GFX_H

typedef unsigned char BYTE;
typedef enum {GM_640x480x16,GM_320x200x256,GM_640x400x256,GM_640x480x256
			 ,GM_800x600x256,GM_1024x768x256} GraphicsMode;
typedef enum {GS_OK,GS_NA} GraphicsStatus;

typedef enum {C_BLACK,C_BLUE,C_GREEN,C_CYAN,C_RED,C_MAGENTA,C_BROWN,C_WHITE,
              C_GRAY,C_LIGHTBLUE,C_LIGHTGREEN,C_LIGHTCYAN,C_LIGHTMAGENTA,
              C_YELLOW,C_BRIGHTWHITE} cColor;

typedef struct{
long width, height;
long numColors;
} gfxConfig;

GraphicsStatus initGraphics(gfxConfig *gc, GraphicsMode gm);
void closeGraphics( void );
void writePixel( int, int);
void writePixelColor( int, int, BYTE);
void writeLine( int, int, int, int);
void writeLineColor( int, int, int, int, BYTE);
void writeCircle( int, int, int);
void writeCircleColor( int, int, int, BYTE);
void writeFillCircleColor( int, int, int, BYTE);
void writeBox( int, int, int, int);
void writeBoxColor( int, int, int, int, BYTE);
void writeFillBox( int, int, int, int);
void writeFillBoxColor( int, int, int, int, BYTE);
void writeText(int, int, BYTE*);
void writeTextColor( int, int, BYTE*, BYTE);
void outText(long col,long row,char * s,long color);
void drawWindow( int, int, int, int, int);
void drawMenu( void );
void waitVS(void);

#endif

/* gfx.h */

