/* vfont.h */
/* Created 5/01/94 */
/* Copyright 1994 Ken Hawkins */
/* All Rights Reserved */

#ifndef VFONT_H
#define VFONT_H

#define VF_ALIGN_LEFT   0
#define VF_ALIGN_CENTER 1
#define VF_ALIGN_RIGHT  2

typedef struct vseg {
  def3 * v[2];
} vseg;

typedef struct vchar {
  long numPoints;
  def3 * point;
  long numSegs;
  vseg * seg;
} vchar;

typedef struct vfont {
  long id;
  long width,height;
  long interCharSpace,interLineSpace;
  long numChars;
  vchar * vc;
} vfont;

void drawVChar(long page,
			   vchar * vc,
               matrix34 * m,vec3 * offset,
			   vec3 * center,long color);

void drawVString(long page,
				 vfont * vf,char * s,
                 matrix34 * m,vec3 * center,
				 long alignment,long color);

long loadVFont(char * filename,vfont * vf);

void freeVFontMembers(vfont * vf);

void freeVFont(vfont * vf);

void scaleVFont(vfont * vf,coord x,coord y,coord z);

#endif

/* vfont.h */

