/* vgfx.h */
/* Created 1/13/95 */
/* Copyright 1998 Ken Hawkins */
/* All Rights Reserved */

#ifndef VGFX_H
#define VGFX_H

#define VMODE_320x200_256 0x13

#define DCOLOR(r,g,b) (((b)*3/255)<<6)|(((g)*7/255)<<3)|((r)*7/255)
#define DAC(r,g,b) (((b)<<6)|((g)<<3)|(r))

void setOverscanColor(long color);

void setPalette(long * colors,long count);

void setVmode(long mode);

void restoreVmode(void);

void initXmode(void);

void deInitXmode(void);

void computeOffsets(long stereo);

void setViewPageAddr(ulong addr);

void waitVS(void);

void clearpage400(long page,long color);

void setPixel(long page,long x,long y,long color);

void drawLine(long page,vec2 * l,long color);

void fillRect(long page,vec2 * extent,long color);

void dline(long page,vec2 * v,long color);

#endif

/* vgfx.h */
#ifndef _TwkUser_h
#define _TwkUser_h

/*
	xxxxADDR defines the base port number used to access VGA component xxxx,
	and is defined for xxxx =
		ATTRCON     -   Attribute Controller
		MISC        -   Miscellaneous Register
		VGAENABLE   -   VGA Enable Register
		SEQ         -   Sequencer
		GRACON      -   Graphics Controller
		CRTC        -   Cathode Ray Tube Controller
		STATUS      -   Status Register
*/

#define ATTRCON_ADDR    0x3c0
#define MISC_ADDR       0x3c2
#define VGAENABLE_ADDR  0x3c3
#define SEQ_ADDR        0x3c4
#define GRACON_ADDR     0x3ce
#define CRTC_ADDR       0x3d4
#define STATUS_ADDR     0x3da


/*
	Note that the following C definition of Register is not compatible
	with the C++ definition used in the source code of TWEAK itself!
*/

typedef struct
	{
	unsigned short port;
	unsigned char index;
	unsigned char value;
	} Register;

typedef Register *RegisterPtr;

void readyVgaRegs(void);
void outRegArray(Register *r, int n);
void outReg(Register r);
int loadRegArray(char *fpath, RegisterPtr *array);

#endif

/* Created 1/9/94 */
/* Copyright 1998 Ken Hawkins */
/* All Rights Reserved */

#ifndef VUTIL_H
#define VUTIL_H

void vsync(void);
void set_vpage_adr(long addr);

#ifdef __WATCOMC__
// Insure correct symbols regardless of calling convention.
#pragma aux vsync "*_"
#pragma aux set_vpage_adr "*_" parm [eax]
#endif

#endif

/* vutil.h */
