###############################################
#            Generic Watcom Makefile          #
###############################################

.EXTENSIONS:
.EXTENSIONS: .o32 .c .cpp .obj .asm

CC      = wcc386
CPP     = wpp386
ASM     = wasm
ASMFLAGS =
LINK    = wlink
!ifdef LIBSLOC
LIBSLOC = $+ $(LIBSLOC);$(%soft)\lib $-
!else
LIBSLOC = $+ $(%soft)\lib $-
!endif
INCLOC  = $+ $(%soft)\include $-
INCLUDE += $+ /I=$(INCLOC) $-
#DEBUG   = /d1
MEMMDL  = /mf
ALIGN   = /zp4

#USE_STACK_ARGS = 1
#USE_4GWPRO     = 1

!ifndef USE_4GWPRO
!  ifdef %use4gwpro
!    define USE_4GWPRO
!  endif
!endif

!ifndef OPTI
!ifdef USE_STACK_ARGS
OPTI    = /oneatx /5s
!else
OPTI    = /oneatx /5r
!endif
!endif

!ifndef MATH
MATH    = /fpi #/fpi87
!endif

CFLAGS  += /bt=dos $(MEMMDL) $(ALIGN) $(OPTI) $(MATH) $(DEBUG) $(INCLUDE)

!ifdef DEBUG
!ifndef LDEBUG
LDEBUG  = debug lines
!endif
!endif

LFLAGS  = system dos4g $(LDEBUG) op stack=32K libpath $(LIBSLOC)
LOBJS   =

!ifdef USE_STACK_ARGS
LLIBS   = emu387,math387s,clib3s
!else
LLIBS   = emu387,math387r,clib3r
!endif

LNK     = watcom.lnk

# $+ and $- cause immediate macro expansion start/stop.

ext      = h
HEADERS  = $+ $(FILES) $(EXTFILES) $(ASMFILES) $-
ext      = o32
OBJS     = $+ $(FILES) $-

!ifdef APPS
APPSOBJS = $+ $(APPS) $-
!endif

EXTOBJS  = $+ $(EXTFILES) $-
ext      = obj
ASMOBJS  = $+ $(ASMFILES) $-
OBJS    += $+ $(ASMOBJS) $-
ext      = exe

!ifdef APPS
APPSEXES = $+ $(APPS) $-
!endif

!ifdef LIBS
LLIBS +=$+,$(LIBS)$-
!endif

!ifdef LIBNAME
LLIBS +=,
LIBNAMEVER = $(LIBNAME)$(VERSION)
LIBNAMEVERH   = $(LIBNAMEVER).h
LIBNAMEVERLIB = $(LIBNAMEVER).lib
LIBNAMEVERLNK = $(LIBNAMEVER).lnk
!endif

.c.o32: $(HEADERS)
	set _ARGS = $(CFLAGS) -fo=$^*.o32 $<
	$(CC) @_ARGS

.cpp.o32: $(HEADERS)
	set _ARGS = $(CFLAGS) -fo=$^*.o32 $<
	$(CPP) @_ARGS

.asm.obj: $(HEADERS)
	$(ASM) $(ASMFLAGS) $<

all: $(LIBNAMEVERLIB) $(APPSEXES) .symbolic
	@%null

!ifdef APPSEXES

$(APPSEXES): $(LIBNAMEVERLIB) $(APPSOBJS) $(EXTOBJS) $(LNK)
	$(LINK) @$(LNK) file $^*.o32 name $^*4.exe
!ifdef USE_4GWPRO
	4gwbind 4gwpro $^*4.exe $^@ -V
!else
        copy $^*4.exe $^@
!endif
!ifdef LDEBUG
	wstrip $^@
!endif

!endif

!ifdef LIBNAME

$(LIBNAMEVERLIB): $(OBJS) watcom.mak $(LIBNAMEVERLNK)
	wlib -n $(LIBNAMEVERLIB) @$(LIBNAMEVERLNK)

$(LIBNAMEVERLNK): $(OBJS) watcom.mak
	%create $(LIBNAMEVERLNK)
	@for %i in ($(OBJS)) do @%append $(LIBNAMEVERLNK) +%i
!ifdef INCLIBS
	@for %i in ($(INCLIBS)) do @%append $(LIBNAMEVERLNK) +$(LIBSLOC)\%i.lib
	%create $(LIBNAMEVER).h
	@for %i in ($(INCLIBS)) do @type $(%soft)\include\%i.h >>$(LIBNAMEVERH)
!endif

update: .symbolic
	wmake -f watcom.mak
!ifdef INCLIBS
	copy $(LIBNAMEVERH) $(INCLOC)
!else
	%create $(LIBNAMEVERH)
	@for %i in ($(HEADERS)) do @type %i >>$(LIBNAMEVERH)
	move $(LIBNAMEVERH) $(INCLOC)
!endif
	copy $(LIBNAMEVERLIB) $(LIBSLOC)

remake: .symbolic
	wmake -f watcom.mak clean
	wmake -f watcom.mak update

!else

remake: .symbolic
	wmake -f watcom.mak clean
	wmake -f watcom.mak

!endif

$(LNK) : watcom.mak
	%create $(LNK)
	@%append $(LNK) $(LFLAGS)
	@for %i in ($(EXTOBJS)) do @%append $(LNK) file %i
	@%append $(LNK) library $(LLIBS)$(LIBNAMEVERLIB)

link:   .symbolic
	@wtouch watcom.mak
	wmake -f watcom.mak

clean:  .symbolic
	del *.exe
	del *.o32
	del *.obj
	del *.lib
	del *.lnk
	del *.bak
	del *.err
