#include <io.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <bios.h>
#include <fcntl.h>
#include <memory.h>
#include <malloc.h>
#include <math.h>
#include <string.h>
#include "vstrack1.h"


#define PIC_ICR   0X20
#define PIC_IMR   0X21
#define PIC_EOI   0x20
#define MOUSE_VEC 0x33


int DONEFLAG=0;

int tx,ty,x,y,org_x,org_y,track_x,track_y;
short vector;
static volatile TrackerData td;
static volatile TrackerStatus ts;
static volatile TrackerPort trackerPort;

void (_interrupt _far *old_timer_ISR)();
void (_interrupt _far *old_ISR)();
void (_interrupt _far *old_MOUSE_ISR)();

void getMouse(short * x,short * y) {
union REGS regs;
  regs.x.ax = 0x03;
  int86(MOUSE_VEC,&regs,&regs);
  *x = regs.x.cx;
  *y = regs.x.dx;
} // getMouse

void setMouse(short x,short y) {
union REGS regs;
  regs.x.ax = 0x04;
  regs.x.cx = x;
  regs.x.dx = y;
  int86(MOUSE_VEC,&regs,&regs);
} // setMouse

void moveMouse(short dx,short dy) {
short x,y;
  getMouse(&x,&y);
  setMouse(x+dx,y+dy);
} // moveMouse



void start_track(void) {
unsigned char far *vect;
int i;



	 printf("Initializing tracker.\n");

  ts = initTrackerSearch(&td,&trackerPort,9600,timerSecs(2));
  printf("%s.\n",trackerInfo(ts));
  if (ts != TS_OK) {
	 closeTracker(&td);
	 return(0);
  } // if

  ts = sendTrackerCMD(&td,"!M2,P,B\r",timerSecs(2));
  if (ts != TS_OK) {
	 printf("%s.\n",trackerInfo(ts));
	 closeTracker(&td);
	 return(0);
  } // if

  requestTrackerData(&td);
  ts = readTracker(&td,timerSecs(1));

  org_x = td.euler.y;
  org_y = -(td.euler.x);

  for(vector = 0x60; vector < 0x67; vector++) {
		vect = *(char far * far *)(vector*4);
		if(!vect || *vect == 0xcf) break;
	 } // for
	 if (vector == 0x67) {
		printf("Unable to locate a free vector from (0x60-0x67).\n");
		closeTracker(&td);
		exit(1);
	 } // if
 printf("Using interrupt vector 0x%x\n", vector);
}// start_track




void _interrupt _far Poll_ISR(void)  {

  _asm sti

  if (!DONEFLAG) {
	  DONEFLAG=1;
	  ts = readTracker(&td,timerSecs(1));
	  requestTrackerData(&td);
  }
	outp(PIC_ICR,PIC_EOI);
}// Poll_ISR

void _interrupt _far Calc_ISR(void)  {

	_asm sti

	if (DONEFLAG) {

		tx = org_y-td.euler.y;
		 ty = org_x-(-(td.euler.x));
	} else
		 {resetTracker(&td,timerTSecs(1));}// if

  outp(PIC_ICR,PIC_EOI);
}

void _interrupt _far Mouse_ISR(void)  {

	 (old_MOUSE_ISR)();

 if (tx&ty) {
	 _asm sti
	 DONEFLAG=0;
	 org_x = td.euler.y;
	 org_y = -(td.euler.x);
	 moveMouse(tx,ty);

	 outp(PIC_ICR,PIC_EOI);
  }

}


void main(int argc, char **argv)
 {
	 start_track();

	old_timer_ISR = _dos_getvect(0x1c);
	_dos_setvect(0x1c,Mouse_ISR);
	old_ISR = _dos_getvect(vector);
	_dos_setvect(vector,Calc_ISR);
	old_MOUSE_ISR = _dos_getvect(MOUSE_VEC);
	_dos_setvect(MOUSE_VEC,Mouse_ISR);

			while (1) {
			if (kbhit() && getch() == 'q') break;

	printf("org_x  %i  org_y  %i  tx %i ty  %i x %i y %i\n",org_x,org_y,tx,ty,x,y);

		}//while
		  _dos_setvect(0x1c,old_timer_ISR);
		  _dos_setvect(vector,old_ISR);
		  _dos_setvect(MOUSE_VEC,old_MOUSE_ISR);
 }
