/* test.c */
/* Created 12/12/94 John Schwab */

#include <stdio.h>
#include <math.h>
#include "gfx.h"

void waitVS(void);

typedef struct {float x,y,z;} vec3;
typedef struct {vec3 c,o;} lvec;

int visible = 1;
gfxConfig gc;

void rotateXYZ( float *x, float *y, float *z, float yaw, float pitch, float roll){
 double fx, fy, fz;
 fx = sin( roll ) * (*y) + cos( roll ) * (*x);
 fy = cos( roll ) * (*y) - sin( roll ) * (*x);
 fz = cos( pitch ) * (*z) - sin( pitch ) * fy;
 *y = sin( pitch ) * (*z) + cos( pitch ) * fy;
 *x = cos( yaw ) * fx - sin( yaw ) * fz;
 *z = sin( yaw ) * fx + cos( yaw ) * fz;
}

void drawProjections(lvec * v){
// scale vector to fit window
  v->c.x /= 303.0;
  v->c.y /= 303.0;
  v->c.z /= 303.0;

  if( visible ){
// clear projection of vector on x/y plane
	writeLineColor( 106, 120, 106 + (int)v->o.x, 120 + (int)v->o.y, 7);
// clear projection of vector on x/z plane
	writeLineColor( 320, 120, 320 + (int)v->o.x, 120 + (int)v->o.z, 7);
// clear projection of vector on y/z plane
	writeLineColor( 531, 120, 531 + (int)v->o.y, 120 + (int)v->o.z, 7);

// draw new grid
	writeLineColor( 1, 120, 212, 120, 14);
	writeLineColor( 106, 1, 106, 239, 14);
	writeLineColor( 214, 120, 426, 120, 14);
	writeLineColor( 320, 1, 320, 239, 14);
	writeLineColor( 428, 120, 638, 120, 14);
	writeLineColor( 531, 1, 531, 239, 14);

// draw projection of vector on x/y plane
	writeLineColor( 106, 120, 106 + (int)v->c.x, 120 + (int)v->c.y, 4);
// draw projection of vector on x/z plane
	writeLineColor( 320, 120, 320 + (int)v->c.x, 120 + (int)v->c.z, 4);
// draw projection of vector on y/z plane
	writeLineColor( 531, 120, 531 + (int)v->c. y, 120 + (int)v->c.z, 4);
  }

// draw pixels for trails
  writePixelColor( 108 + (int)v->c.x, 122 + (int)v->c.y, 1);
  writePixelColor( 322 + (int)v->c.x, 122 + (int)v->c.z, 1);
  writePixelColor( 533 + (int)v->c.y, 122 + (int)v->c.z, 1);

  v->o = v->c;
}

#if 0
void drawMenu(){
  drawWindow( 0, gc.height / 24, gc.width / 32, gc.height / 6, 1);
  drawWindow( 0, gc.height / 3, gc.width / 32, gc.height / 6, 1);
  drawWindow( 0, gc.height / 1.71428, gc.width / 32, gc.height / 6, 1);
  drawWindow( 0, gc.height / 1.2, gc.width / 32, gc.height / 6, 1);
  drawWindow( gc.width / 5.3, gc.height / 24, gc.width / 32, gc.height / 6, 1);
  drawWindow( gc.width / 5.3, gc.height / 3, gc.width / 32, gc.height / 6, 1);
  drawWindow( gc.width / 5.3, gc.height / 1.71428, gc.width / 32, gc.height / 6, 1);
  drawWindow( gc.width / 5.3, gc.height / 1.2, gc.width / 32, gc.height / 6, 1);
  drawWindow( gc.width / 2, 0, gc.width / 4, gc.height / 8, 1);
  drawWindow( gc.width / 2, gc.height / 8, gc.width / 4, gc.height / 8, 1);
  drawWindow( gc.width / 2, gc.height / 4, gc.width / 4, gc.height / 8, 1);
  drawWindow( gc.width / 2, gc.height / 2.6, gc.width / 4, gc.height / 8, 1);
  drawWindow( gc.width / 1.3, 0, gc.width / 4, gc.height / 8, 1);
  drawWindow( gc.width / 1.3, gc.height / 8, gc.width / 4, gc.height / 8, 1);
  drawWindow( gc.width / 1.3, gc.height / 4, gc.width / 4, gc.height / 8, 1);
  drawWindow( gc.width / 1.3, gc.height / 2.6, gc.width / 4, gc.height / 8, 1);

}
#endif

#define         TWOPI   6.2831853

void main(){
  GraphicsStatus gs;
  int mode;
  lvec magnetic;
  char string[20];
  char quit;
  float yaw = 0, pitch = 0, roll = 0;

  magnetic.o.x = 0;
  magnetic.o.y = 0;
  magnetic.o.z = 0;

  gs = initGraphics( &gc, GM_640x480x16);


  switch( gs ){
	case GS_OK:
//        printf( "Initialized Graphics Ok\n" );
	  break;
	case GS_NA:
	  printf( "Graphics Mode Not Available\n" );
	  break;
  }

  drawWindow( 0, 0, 213, 240, 1);
  drawWindow( 214, 0, 213, 240, 1);
  drawWindow( 428, 0, 212, 240, 1);
  writeTextColor( 0, 240, "x/y plane", 1);
  writeTextColor( 214, 240, "x/z plane", 1);
  writeTextColor( 428, 240, "y/z plane", 1);
  quit = 0;
  do{
	magnetic.c.x = 0;
	magnetic.c.y = 0;
	magnetic.c.z = 16384;
	rotateXYZ( &magnetic.c.x, &magnetic.c.y, &magnetic.c.z, yaw, pitch, roll);
	waitVS();
	writeFillBoxColor( 0, 270, 640, 290, 0);
	sprintf( string, "roll: %3.4f", roll);
	writeTextColor( 0, 270, &string, 1);
	sprintf( string, "yaw: %3.4f", yaw);
	writeTextColor( 214, 270, &string, 1);
	sprintf( string, "pitch: %3.4f", pitch);
	writeTextColor( 428, 270, &string, 1);

	drawProjections( &magnetic );
	yaw += .05;
	if( yaw > TWOPI) yaw -= TWOPI;
	pitch -= .1;
	if( pitch < 0) pitch += TWOPI;
	roll -= .075;
	if( roll < 0) roll += TWOPI;
	if (kbhit()) {
	  char ch = getch();
	  switch (ch) {
		case ' ': visible ^= 1; break;
		case 27 : quit = 1; break;
	  } // switch
	} // if
  } while (!quit);
  CloseGraphics();
} // main

