/* ptest.c */
/* Simple test that prints data to screen. */
/* Created  2/9/95 */
/* Ken Hawkins */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include "imath1.h"
#include "timer1.h"
#include "vector1.h"
#include "convert1.h"
#include "tracker.h"

void main(int argc,char ** argv) {
TrackerData td;
TrackerStatus ts;
long timeout = timerSecs(2);
char verstr[TRACKER_VER_LEN];
long hver,hrev,fver,frev;
float hversion,fversion;
extern long debugTrackerIO;

  debugTrackerIO = 1;

  printf("Initializing tracker.\n");

  ts = initTracker(&td,TP_COM1,9600,timeout);

  printf("%s.\n",trackerInfo(ts));
  if (ts != TS_OK) {
	closeTracker(&td);
	exit(0);
  } // if

  ts = getTrackerVerStr(&td,verstr,timeout);

  if (ts != TS_OK) {
	printf("%s.\n",trackerInfo(ts));
	closeTracker(&td);
	exit(0);
  } // if

  printf("Tracker Version String:\n%s\n",verstr);

  ts = getTrackerVerRev(&td,&hver,&hrev,&fver,&frev,timeout);

  if (ts != TS_OK) {
	printf("%s.\n",trackerInfo(ts));
	closeTracker(&td);
	exit(0);
  } // if

  hversion = (float)hver + (float)hrev/1000.;
  fversion = (float)fver + (float)frev/1000.;

  printf("Hardware Version %7.3f Firmware Version %7.3f\n",hversion,fversion);

  ts = sendTrackerCMD(&td,"!M1,P,B\r",timerSecs(2));
  if (ts != TS_OK) {
	printf("%s.\n",trackerInfo(ts));
	closeTracker(&td);
	exit(0);
  } // if

  requestTrackerData(&td);

  while (1) {
	float y,p,p2,r;
	if (kbhit() && getch() == 'q') break;

	ts = readTracker(&td,timerSecs(1));
	if (ts != TS_OK) {
	  printf("\n%s.\n",trackerInfo(ts));
	} // if
	requestTrackerData(&td);

	y = TOFLOAT(td.euler.y);
	p = TOFLOAT(td.euler.x);
	r = TOFLOAT(td.euler.z);

#if 1
//    printf("x %6ld y %6ld z %6ld y %6.2f p %6.2f r %6.2f\n",
//      td.magnetic.x,td.magnetic.y,td.magnetic.z,y,p,r);
	printf("x %6ld y %6ld z %6ld y %6.2f p %6.2f r %6.2f\n",
	  td.magnetic.x,td.magnetic.y,td.magnetic.z,y,p,r);
#endif

  } // while

  closeTracker(&td);

} // main

/* ptest.c */

