/* rat.c */
/* Test the rat ("big mouse", a.k.a the tracker hidden in mouse clothing). */
/* Created 1/4/95 */
/* Ken Hawkins */

#include <stdio.h>
#include <math.h>
#include "imath1.h"
#include "vector1.h"
#include "convert1.h"
#include "serial1.h"
#include "tracker.h"
#include "tcal.h"

char b1[16],b2[16],b3[16];

char * tb(char * buff,long val) {
long i,c;
  c = 0;
  for (i=0; i < 8; i++) {
    if (val & (1<<7)) buff[c] = '1';
    else buff[c] = '0';
    val <<= 1;
    c++;
    if (c == 4) buff[c++] = '.';
  } // for
  buff[9] = 0;
  return buff;
} // tb

void cursor(long x,long y) {
static short * om = 0;
short * m = (short *)0xb8000L;
unsigned long oa;
  if (x < 0 || x > 79 || y < 0 || y > 24) return;
  m += x + y*80;
  if (!om) om = m;
  *(long *)om = ' ' | (' '<<16);
  oa = '*' | (2<<8);
  oa |= oa << 16;
  *(long *)m = oa;
  om = m;
} // cursor

void main(int argc,char ** argv) {
TrackerData td;
TrackerStatus ts;
unsigned char buff[32];
long count;
signed char x,y;
long sx=0,sy=0;

  ts = initTracker(&td,TP_COM1,1200,timerSecs(3));
  printf("%s.\n",trackerInfo(ts));
  if (ts != TS_OK) {
//    closeTracker(&td);
//    exit(0);
  } // if

  if (argc == 1) {

  ts = sendTrackerCMD(&td,"!M3,0,B,5,5,1,1,1,1\r",timerTSecs(5));
  if (ts != TS_OK) {
    printf("%s.\n",trackerInfo(ts));
  } // if

  } // if

// Startup mouse mode
  requestTrackerData(&td);

  count = 0;
  while (1) {
    if (kbhit() && getch() == 'q') break;

//    cursor(sx/4,sy/4);

    if (!rxBuffEmpty(td.sd)) {
      buff[count++] = readSer(td.sd);
      if (count == 3) {
        unsigned char lox,hix,loy,hiy;
        lox =   buff[1] & ~(3<<6);
        hix =  (buff[0] & 0x3) << 6;
        loy =   buff[2] & (~(3<<6));
        hiy = ((buff[0]>>2) & 0x3) << 6;
        x = lox | hix;
        y = loy | hiy;
#if 0
        printf("0x%x 0x%x 0x%x ",buff[0],buff[1],buff[2]);
        printf("%s %s %s ",tb(b1,buff[0]),tb(b2,buff[1]),tb(b3,buff[2]));
        printf("x %d y %d\n",(long)x,(long)y);
#else
        sx += x;
        sy += y;
        if (sx < 0)  sx = 0;
        if (sx > 79*4) sx = 79*4;
        if (sy < 0)  sy = 0;
        if (sy > 24*4) sy = 24*4;

        cursor(sx/4,sy/4);
#endif
        count = 0;
      } else if (count == 1) { // check for valid header
        if (!(buff[0] & (1<<6))) {
          printf("Bad header\n");
          count = 0;
        } // if
      } // if
    } // if
  } // while

  closeTracker(&td);

} // main

/* rat.c */

