/* tcal.h */
/* Created 12/16/94 */
/* Ken Hawkins */

#ifndef TCAL_H
#define TCAL_H

// Misc. var offsets               // Var size:
#define DATA_MODE_OFFSET      (0x04) // byte
#define MOUSE_MODE_OFFSET     (0x05) // byte
#define SEND_MODE_OFFSET      (0x06) // byte
#define DATA_FORMAT_OFFSET    (0x07) // byte

#define MOUSE_X_SENSI_OFFSET  (0x42) // byte
#define MOUSE_X_THRESH_OFFSET (0x43) // byte

#define MOUSE_Y_SENSI_OFFSET  (0x46) // byte
#define MOUSE_Y_THRESH_OFFSET (0x47) // byte

typedef enum {TA_X,TA_Y,TA_Z,TA_P,TA_R} TrackerAxis;

void setBaseAddr(unsigned long addr);

unsigned long getBaseAddr(void);

TrackerStatus readTrackerMiscVar(TrackerData * td,long offset,long * val);

TrackerStatus readTrackerGain(TrackerData * td,TrackerAxis ta);

TrackerStatus writeTrackerGain(TrackerData * td,TrackerAxis ta);

TrackerStatus readTrackerOffset(TrackerData * td,TrackerAxis ta);

TrackerStatus writeTrackerOffset(TrackerData * td,TrackerAxis ta);

TrackerStatus readTrackerOffsets(TrackerData * td);

TrackerStatus writeTrackerOffsets(TrackerData * td);

TrackerStatus readTrackerGains(TrackerData * td);

TrackerStatus writeTrackerGains(TrackerData * td);

TrackerStatus readTrackerMagFilts(TrackerData * td);

TrackerStatus writeTrackerMagFilts(TrackerData * td);

TrackerStatus readTrackerGrvFilts(TrackerData * td);

TrackerStatus writeTrackerGrvFilts(TrackerData * td);

TrackerStatus readTrackerFilters(TrackerData * td);

TrackerStatus writeTrackerFilters(TrackerData * td);

TrackerStatus readTrackerAllVars(TrackerData * td);

TrackerStatus writeTrackerAllVars(TrackerData * td);

char * getOffsetsStr(TrackerData * td);

char * getGainsStr(TrackerData * td);

char * getFiltersStr(TrackerData * td);

char * getAllVarsStr(TrackerData * td);

#endif

/* tcal.h */

