/* trw.c */
/* Created 12/16/94 */
/* Ken Hawkins */
/* Tracker Memory Read/Write Routines */

#include <stdio.h>
#include "imath1.h"
#include "vector1.h"
#include "timer1.h"
#include "serial1.h"
#include "tracker.h"

#define CTO timerTSecs(30)

TrackerStatus readTracker8(TrackerData * td,long addr,long * val) {
TrackerStatus ts;
char cmd[32];
unsigned char rval,ok;

//  delayTime(timerHSecs(1));

  sprintf(cmd,"!ZR,%04X\r",addr & 0xffff);
  writeSerString(td,cmd);

  ts = readPacket(td,&rval,sizeof(rval),CTO); // value
  if (ts != TS_OK) return ts;

  if (debugTrackerIO) {
    printf("Reading Packet:"); fflush(stdout);
  } // if

  ts = readPacket(td,&ok,sizeof(ok),CTO);     // 'O'
  if (ts != TS_OK) return ts;

  if (debugTrackerIO) printf(" OK\n");

  *val = (unsigned long)rval;
  return ts;

} // readTracker8

TrackerStatus writeTracker8(TrackerData * td,long addr,long val) {
TrackerStatus ts;
char cmd[32];
long rval;

//  delayTime(timerHSecs(1));

  sprintf(cmd,"!ZW,%04X,%02X\r",addr & 0xffff,val & 0xff);
  ts = sendTrackerCMD(td,cmd,CTO);
//  if (ts != TS_OK) return ts;
  return ts;

#if 0
  ts = readTracker8(td,addr,&rval);
  if (ts != TS_OK) return ts;
  if (val == rval) return TS_OK;
  else return TS_WRITEVERIFY;
#endif
} // writeTracker8

TrackerStatus readTracker16(TrackerData * td,long addr,long * val) {
TrackerStatus ts;
long lo,hi;
  ts = readTracker8(td,addr,&hi);   // hi bits
  if (ts != TS_OK) return ts;
  ts = readTracker8(td,addr+1,&lo); // lo bits
  *val = (signed short)((hi << 8) | lo);
  return ts;
} // readTracker16

TrackerStatus writeTracker16(TrackerData * td,long addr,long val) {
TrackerStatus ts;
  ts = writeTracker8(td,addr,(unsigned short)val>>8);     // hi bits
  if (ts != TS_OK) return ts;
  ts = writeTracker8(td,addr+1,val&0xff); // lo bits
  return ts;
} // writeTracker16

/* trw.c */
